unit code;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,FileCtrl;

type
  TForm1 = class(TForm)
    katalog: TEdit;
    Button1: TButton;
    pbar: TProgressBar;
    Button2: TButton;
    wolnem: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
s:string;
begin
// uses FileCtrl
SelectDirectory('Wybierz katalog: ','My Computer',s);
  if (s<>'') then
  begin
  katalog.Text:=s;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
const
rozmiar_bufora=1024;
var
buf:array [1..rozmiar_bufora] of char; // bufor odczytu/zapisu
s:string;
fin,fout:TFileStream;
dl,ile,reszta,i,j:dword;
f_count:dword; // ile mamy plikw
rozmiar:dword;
odp:integer;
dir:string;
z:char;
begin
  if DirectoryExists(katalog.Text)=false then // jeeli katalog nie istnieje
  begin
  odp:=Application.MessageBox(PCHAR('Podany katalog nie istnieje!'+#13+#10+'Czy chcesz go teraz utworzy?'),'Uwaga!',MB_YESNO+MB_ICONQUESTION); // pytamy si czy stworzy
    if odp=ID_NO then // jeeli nie to wychodzimy
    exit;
    if odp=ID_YES then
    begin
      if CreateDirectory(PCHAR(katalog.text),nil)=false then // sprbj stworzy nowy katalog, jeeli operacja si nie powiedzie to wychodzimy
      begin
      MessageBox(0,'Nie mona utworzy katalogu!','Uwaga!',MB_OK+MB_ICONSTOP);
      exit;
      end
      else                      // jeeli powiodo si to wywoaj jeszcze raz zdarzenie OnClick przycisku
      button2.OnClick(button2); // Instaluj, tyle tylko, e teraz przejdzie do sekcji else, czyli, e
    end;                        // katalog ju istnieje
  end
  else // jeeli katalog istnieje
  begin
    try
    dir:=katalog.Text;
    if dir[length(dir)]<>'\' then dir:=dir+'\';
    fin:=TFileStream.Create('files.dat',fmOpenRead);
    fin.Read(f_count,sizeof(f_count)); // odczytujemy ile jest plikw
    // przygotowujemy progressbar
    pbar.Position:=0;
    pbar.Max:=f_count;
      for i:=1 to f_count do
      begin
      fin.Read(dl,sizeof(dl)); // dugo? nazwy pliku
      s:='';
        for j:=1 to dl do // odczytujemy nazw pliku
        begin
        fin.Read(z,1);
        s:=s+z;
        end;
      fin.Read(rozmiar,sizeof(rozmiar)); // rozmiar nowego pliku
      ile:=rozmiar div rozmiar_bufora;
      reszta:=rozmiar-(ile*rozmiar_bufora);
        // sprawdzamy czy katalog w ktrym chcemy umie?ci plik istnieje
        // jeeli nie to sprbjemy go utworzy
        // jeeli to si nie powiedzie to wygenerujmy wyjtek
        // i przejdziemy do sekcji except, ktra wy?wieli stosowny komunikat
        if (DirectoryExists(dir+ExtractFilePath(s))=false) then
        begin
          if ForceDirectories(PCHAR(dir+ExtractFilePath(s)))=false then
          begin
          dl:=strtoint('ble');
          end;
        end;
      fout:=TFileStream.Create(dir+s,fmCreate or fmOpenWrite);
        for j:=1 to ile do
        begin
        fin.Read(buf,sizeof(buf));
        fout.Write(buf,sizeof(buf));
        application.ProcessMessages;
        end;
        fin.Read(buf,reszta);
        fout.Write(buf,reszta);
        application.ProcessMessages;
        pbar.Position:=pbar.Position+1;
      fout.Free;
      end;
    fin.Free;
    MessageBox(0,'Instalacja zakoczona!','Uwaga!',MB_OK+MB_ICONINFORMATION);
    except
      try fin.Free; except end;
      try fout.Free; except end;
    MessageBox(0,'Wystpi bd podczas instalacji!','Uwaga!',MB_OK+MB_ICONSTOP);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
f:TFileStream;
begin
  if FileExists('files.dat')=false then
  begin
  MessageBox(0,'Plik z danymi nie istnieje!','Uwaga!',MB_OK+MB_ICONSTOP);
  Application.Terminate;
  end;

  try
  f:=TFileStream.Create('files.dat',fmOpenRead);
  wolnem.Caption:='Wolne miejsce: '+IntToStr(round(f.Size/1024/1024))+' MB';
  f.Free;
  except
    try f.Free; except end;
  MessageBox(0,'Wystpi nieoczekiwany bd!','Uwaga!',MB_OK+MB_ICONSTOP);
  end;
end;

end.
